'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = styleToCSS;

var _styleUnit = require('style-unit');

// TODO process flexbox polyfill
function styleToCSS(style, disableConvertUnit) {
  var css = '';
  for (var prop in style) {
    if (style.hasOwnProperty(prop)) {
      var val = style[prop];
      if (val != null) {
        css += prop.replace(/([A-Z])/g, '-$1').toLowerCase() + ':';
        if (!disableConvertUnit) {
          // If in server-side render should not convert rem unit that depends on client width
          css += (0, _styleUnit.convertUnit)(val, prop);
        } else {
          css += '' + val;
        }
        css += ';';
      }
    }
  }
  return css;
}
module.exports = exports['default'];